<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
<meta charset="utf-8" />
<meta name="generator" content="Docutils 0.21b.dev: https://docutils.sourceforge.io/" />
<meta name="viewport" content="width=device-width, initial-scale=1" />
<meta name="author" content="Engelbert Gruber" />
<meta name="dcterms.date" content="$Date$" />
<meta name="dcterms.rights" content="This document has been placed in the public domain." />
<title>manpage writer for Docutils</title>
<link rel="schema.dcterms" href="http://purl.org/dc/terms/"/>
<link rel="stylesheet" href="../../docutils/writers/html5_polyglot/minimal.css" type="text/css" />
<link rel="stylesheet" href="../../docutils/writers/html5_polyglot/responsive.css" type="text/css" />
</head>
<body class="with-toc">
<header>
<p><a class="reference external" href="https://docutils.sourceforge.io">Docutils</a> | <a class="reference external" href="../index.html">Overview</a> | <a class="reference external" href="../index.html#project-fundamentals">About</a> | <a class="reference external" href="../index.html#user">Users</a> | <a class="reference external" href="../index.html#ref">Reference</a> | <a class="reference external" href="../index.html#howto">Developers</a></p>
</header>
<main id="manpage-writer-for-docutils">
<h1 class="title">manpage writer for <a class="reference external" href="https://docutils.sourceforge.io/">Docutils</a></h1>
<dl class="docinfo">
<dt class="author">Author<span class="colon">:</span></dt>
<dd class="author"><p>Engelbert Gruber</p></dd>
<dt class="contact">Contact<span class="colon">:</span></dt>
<dd class="contact"><a class="reference external" href="mailto:docutils-develop&#64;lists.sourceforge.net">docutils-develop&#64;lists.sourceforge.net</a></dd>
<dt class="revision">Revision<span class="colon">:</span></dt>
<dd class="revision">$Revision$</dd>
<dt class="date">Date<span class="colon">:</span></dt>
<dd class="date">$Date$</dd>
<dt class="copyright">Copyright<span class="colon">:</span></dt>
<dd class="copyright">This document has been placed in the public domain.</dd>
</dl>
<!-- Minimal menu bar for inclusion in documentation sources
in ``docutils/docs/*/`` sub-diretories.

Attention: this is not a standalone document. -->
<p>This writer explores the possibilities to generate man-pages from
reStructuredText. Man pages are the way for Unix systems to provide
help to the user. GNU does this with (TeX)info-pages.</p>
<nav class="contents" id="contents" role="doc-toc">
<p class="topic-title">Contents</p>
<ul class="simple">
<li><p><a class="reference internal" href="#module-information" id="toc-entry-1">Module information</a></p></li>
<li><p><a class="reference internal" href="#references" id="toc-entry-2">References</a></p></li>
<li><p><a class="reference internal" href="#conventions" id="toc-entry-3">Conventions</a></p></li>
<li><p><a class="reference internal" href="#todo-open-issues" id="toc-entry-4">TODO - Open issues</a></p></li>
</ul>
</nav>
<section id="module-information">
<h2><a class="toc-backref" href="#toc-entry-1" role="doc-backlink">Module information</a><a class="self-link" title="link to this section" href="#module-information"></a></h2>
<p>Unix man page belong into a numbered section, 1 is user commands, 8 contains
administrator commands, the headlines of all manpages are collected into a
database, queryable with the program <span class="docutils literal">apropos</span>, therefore the headline
should contain a short text describing into which group this command belongs.</p>
<p>That information is collected from the title, subtitle and docinfo.</p>
<p>Also man pages have a defined set of sections, that are more or less
mandatory, see <a class="reference internal" href="#references">References</a>.</p>
<p>man pages look like:</p>
<pre class="literal-block">man(1)     Man Pager Utils     man(1)

NAME
    man - an interface to the on-line reference manuals

SYNOPSIS
    man [-c|-w|-tZT device] [-adhu7V] [-m system[,...]] [-L locale]</pre>
<p>in roff formatting:</p>
<pre class="literal-block">.TH man 1 &quot;14 May 2001&quot; &quot;2.3.19&quot; &quot;Manual pager utils&quot;
.SH NAME
man \- an interface to the on-line reference manuals
.SH SYNOPSIS
.\&quot; The general command line
.B man
.RB [\| \-c \||\| \-w \||\| \-tZT
.IR device \|]</pre>
<p>This means we have</p>
<ul class="simple">
<li><p>a title &quot;man&quot;</p></li>
<li><p>a subtitle &quot;an interface to the on-line reference manuals&quot;</p></li>
<li><p>a manual section &quot;1&quot;</p></li>
<li><p>a manual group &quot;Manual pager utils&quot;</p></li>
<li><p>a date &quot;14 May 2001&quot;</p></li>
<li><p>a version &quot;2.3.19&quot;</p></li>
</ul>
</section>
<section id="references">
<h2><a class="toc-backref" href="#toc-entry-2" role="doc-backlink">References</a><a class="self-link" title="link to this section" href="#references"></a></h2>
<p>man pages from section 7, <span class="docutils literal">man</span> and <span class="docutils literal"><span class="pre">man-pages</span></span>.</p>
<div role="list" class="citation-list">
<div class="citation" id="lmht" role="doc-biblioentry">
<span class="label"><span class="fn-bracket">[</span><a role="doc-backlink" href="#citation-reference-1">LMHT</a><span class="fn-bracket">]</span></span>
<p><a class="reference external" href="https://tldp.org/HOWTO/Man-Page/">Linux Man Page Howto</a>.</p>
</div>
</div>
</section>
<section id="conventions">
<h2><a class="toc-backref" href="#toc-entry-3" role="doc-backlink">Conventions</a><a class="self-link" title="link to this section" href="#conventions"></a></h2>
<ul>
<li><p>man pages have a special structure and organization. From the manpage
to <em>man</em>:</p>
<pre class="literal-block">The table below shows the section numbers of the manual followed  by  the
types of pages they contain.

1   Executable programs or shell commands
2   System calls (functions provided by the kernel)
3   Library calls (functions within program libraries)
4   Special files (usually found in /dev)
5   File formats and conventions eg /etc/passwd
6   Games
7   Miscellaneous  (including  macro  packages and conven-
    tions), e.g. man(7), groff(7)
8   System administration commands (usually only for root)
9   Kernel routines [Non standard]

A manual page consists of several parts.

They  may  be  labelled  NAME,  SYNOPSIS,  DESCRIPTION,  OPTIONS,  FILES,
SEE ALSO, BUGS, and AUTHOR.

The  following  conventions apply to the SYNOPSIS section and can be used
as a guide in other sections.

bold text          type exactly as shown.
italic text        replace with appropriate argument.
[-abc]             any or all arguments within [ ] are optional.
-a|-b              options delimited by | cannot be used together.
argument ...       argument is repeatable.
[expression] ...   entire expression within [ ] is repeatable.

The command or function illustration is a pattern that should  match  all
possible  invocations.   In some cases it is advisable to illustrate sev-
eral exclusive invocations as is shown in the SYNOPSIS  section  of  this
manual page.</pre>
</li>
<li><p>new lines in general.</p>
<p>Consecutive blank lines are merged by the viewer but not on printouts.
So one has to be cautious. This is most disturbing when printing
postscript.</p>
<aside class="admonition note">
<p class="admonition-title">Note</p>
<ol class="arabic simple">
<li><p>Roff requests only work when at line start.</p></li>
<li><p>But consecutive blank lines are merged by the viewer but not on
printouts.</p></li>
</ol>
<p>So try the rule start new lines in <span class="docutils literal">visit_</span>-functions, but only if
necessary. E.g. <span class="docutils literal"><span class="pre">field-names</span></span> are already on a new line because of
docutils structure.</p>
</aside>
</li>
<li><p>Indentation, left margin:</p>
<ul>
<li><p>The writer includes two macros <span class="docutils literal">.INDENT</span> and <span class="docutils literal">.UNINDENT</span> that
keep track of the indentation in roff-code, for line-blocks python
keeps track of it. WHAT should be the preferred way ?</p>
<p>But standard macros like <span class="docutils literal">.PP</span> might reset it.</p>
</li>
<li><p>Why do <span class="docutils literal">.RE</span> and <span class="docutils literal">.RS</span> not work?</p></li>
</ul>
<aside class="admonition note">
<p class="admonition-title">Note</p>
<p>Current indent is in register <span class="docutils literal">.i</span>.</p>
</aside>
</li>
<li><p><a class="citation-reference" href="#lmht" id="citation-reference-1" role="doc-biblioref">[LMHT]</a> Filenames are always in italics, except in the SYNOPSIS section,
use:</p>
<pre class="literal-block">.I /usr/include/stdio.h</pre>
<p>and:</p>
<pre class="literal-block">.B #include &lt;stdio.h&gt;</pre>
</li>
<li><p>Tables are possible, via the external processor tbl, although one should
avoid them.</p></li>
</ul>
</section>
<section id="todo-open-issues">
<h2><a class="toc-backref" href="#toc-entry-4" role="doc-backlink">TODO - Open issues</a><a class="self-link" title="link to this section" href="#todo-open-issues"></a></h2>
<ul>
<li><p>How to escape double quotes in macro arguments ?</p></li>
<li><p>Typeset URLs : <span class="docutils literal">man 7 man</span> on linux says use <span class="docutils literal">.UR</span> and <span class="docutils literal">.UE</span>.</p></li>
<li><p>How to typeset command/manpage names in text.</p></li>
<li><p>How to write long syntax lines.</p></li>
<li><p>Line ends around email or web addresses in texts.
How to distinguish something is inline or not ?</p></li>
<li><p>Images and equations are discouraged.</p></li>
<li><p>Lists in admonitions are not intended.</p></li>
<li><p>Encoding declaration <span class="docutils literal">'\&quot; t <span class="pre">-*-</span> coding: <span class="pre">ISO-8859-1</span> <span class="pre">-*-</span></span>
in first line.</p>
<p>BUT if UTF-8 is declared tables are no longer processed.</p>
</li>
<li><p>Input and output encoding are problematic at least.</p></li>
</ul>
</section>
</main>
<footer>
<p><a class="reference external" href="manpage.txt">View document source</a>.
Generated on: 2023-09-13 17:06 UTC.
Generated by <a class="reference external" href="https://docutils.sourceforge.io/">Docutils</a> from <a class="reference external" href="https://docutils.sourceforge.io/rst.html">reStructuredText</a> source.
</p>
</footer>
</body>
</html>
